/****************************************************************************/
/*                                                                          */
/*  This file is distributed as part of the BCP_VRP package                 */
/*                                                                          */
/*  (c) Copyright 2006 by Ricardo Fukasawa, Humberto Longo,                 */
/*  Marcus Poggi de Aragao, Marcelo Reis and Eduardo Uchoa                  */
/*                                                                          */
/*  Permission is granted for academic research use.  For other uses,       */
/*  contact the authors for licensing options.                              */
/*                                                                          */
/*  Use at your own risk.  We make no guarantees about the                  */
/*  correctness or usefulness of this code.                                 */
/*                                                                          */
/****************************************************************************/

////////////////////////////////////////////
// File: CParameters.cpp                    //
////////////////////////////////////////////
// Class with the parameters of the       //
// branch-and-cut-and-price algorithm     //
////////////////////////////////////////////

#include "CParameters.h"
#include "Constants.h"

//---------------------------------------------------------------------------//

CParameters::CParameters()
{
   // Set default values
   cutEps = CUTEPS;
   intEps = INTEPS;
   objEps = OBJEPS;
   infinity = INFINITY_VALUE;
   maxColPoolSize = MAX_COL_POOL_SIZE;
   maxCutPoolSize = MAX_CUT_POOL_SIZE;
   objInteger = false;

   // Convention - If objint is false and fracprec == 0, 
   // then the precision is the machine precision.
   fracprec = 0;

   nodeSel = NODE_SELECT_DFS; 
}

//---------------------------------------------------------------------------//

CParameters::~CParameters()
{
   // Restore default values
   cutEps = CUTEPS;
   intEps = INTEPS;
   objEps = OBJEPS;
   infinity = INFINITY_VALUE;
   maxColPoolSize = MAX_COL_POOL_SIZE;
   maxCutPoolSize = MAX_CUT_POOL_SIZE;
   objInteger = false;
}

//---------------------------------------------------------------------------//
