/****************************************************************************/
/*                                                                          */
/*  This file is distributed as part of the BCP_VRP package                 */
/*                                                                          */
/*  (c) Copyright 2006 by Ricardo Fukasawa, Humberto Longo,                 */
/*  Marcus Poggi de Aragao, Marcelo Reis and Eduardo Uchoa                  */
/*                                                                          */
/*  Permission is granted for academic research use.  For other uses,       */
/*  contact the authors for licensing options.                              */
/*                                                                          */
/*  Use at your own risk.  We make no guarantees about the                  */
/*  correctness or usefulness of this code.                                 */
/*                                                                          */
/****************************************************************************/

////////////////////////////////////////////
// File: Cvrp_bcp.cpp                     //
////////////////////////////////////////////
// Main function for CVRP_BCP             //
////////////////////////////////////////////

//---------------------------------------------------------------------------//

#include "CVRPFullGraph.h"
#include "CVRPMaster.h"
#include "CVRPBBNode.h"
#include "Constants.h"


//---------------------------------------------------------------------------//

int main(int argc, char* argv[])
{
  CVRPFullGraph gMain;
  CVRPMaster master;
  
  
  master.setGraph( & gMain );
  master.params->setObjInteger( true );
  master.readData( argc, argv );
  
  try
  {
    master.optimize();
  }
  catch( int& e )
  {
    master.writeLog( true, "Program ABORTED: Error number %d\n", e );
    return 1;
  }
  catch(...)
  {
    master.writeLog( true, "Program ABORTED: NO Error number\n" );
    return 1;
  }

  return 0;
}

//---------------------------------------------------------------------------//
