#ifndef RFW_STACK_H
#define RFW_STACK_H

#include <assert.h>

template <class T, bool debug=true> class RFWStack {
	private:
		T *stack;
		int top, size;

	public:
		bool isFull() {return (top==size);}

		void push (T i) {
			if (debug) assert (top<size);
			stack[++top] = i;
		}

		T pop() {
			if (debug) assert (!isEmpty());
			return (stack[top--]);
		};

		bool isEmpty() {return (top==0);};

		int getNElements() {return top;}

		T peek (int p) {
			if (debug) assert (p>0 && p<=top);
			return (stack[p]);
		}

		RFWStack (int s) {
			if (debug) assert (s>0);
			top = 0;
   			size = s;
			stack = new T [size+1];
		};

		~RFWStack () {delete [] stack;};
};

#endif
